package net.npaka.imageex;
import android.content.res.Resources;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Rect;
import android.view.View;

//C[W̕`
public class ImageView extends View {
    private Bitmap image;//C[W

    //RXgN^
    public ImageView(Context context) {
        super(context);
        setBackgroundColor(Color.WHITE);

        //摜̓ǂݍ(1)
        Resources r=context.getResources();
        image=BitmapFactory.decodeResource(
            r,R.drawable.sample);    
    }

    //`
    @Override 
    protected void onDraw(Canvas canvas) {
        //C[W̕`(2)
        canvas.drawBitmap(image,0,0,null);
        
        //C[W̊gk`(3)
        int w=image.getWidth();
        int h=image.getHeight();
        Rect src=new Rect(0,0,w,h);
        Rect dst=new Rect(0,200,w*2,200+h*2);
        canvas.drawBitmap(image,src,dst,null);
    }
}