package net.npaka.touchex;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.View;
import android.view.MotionEvent;

//^b`Cxg̏
public class TouchView extends View {
    private int touchX=0;        //^b`XW
    private int touchY=0;        //^b`YW
    private int touchAction=-999;//^b`ANV
    private int ballX=0;         //{[XW
    private int ballY=0;         //{[YW
    private int ballAction=-999; //{[ANV
    
    //RXgN^
    public TouchView(Context context) {
        super(context);
        setBackgroundColor(Color.WHITE);

        //tH[JXw
        setFocusable(true);
    }
    
    //`
    @Override 
    protected void onDraw(Canvas canvas) {
        String str;
        
        //`IuWFNg̐
        Paint paint=new Paint(); 
        paint.setAntiAlias(true);
        paint.setTextSize(32);
        
        //^b`XYW̕`
        canvas.drawText("TouchXY>"+touchX+","+touchY,0,40*1,paint);
        
        //^b`ANV̕`
        str="NONE";
        if (touchAction==MotionEvent.ACTION_DOWN)   str="ACTION_DOWN";
        if (touchAction==MotionEvent.ACTION_MOVE)   str="ACTION_MOVE";
        if (touchAction==MotionEvent.ACTION_UP)     str="ACTION_UP";
        if (touchAction==MotionEvent.ACTION_CANCEL) str="ACTION_CANCEL";
        canvas.drawText("TouchAction>"+str,0,40*2,paint);

        //{[XYW̕`
        canvas.drawText("TrackballXY>"+ballX+","+ballY,0,40*3,paint);
        
        //{[ANV̕`
        str="NONE";
        if (ballAction==MotionEvent.ACTION_DOWN)   str="ACTION_DOWN";
        if (ballAction==MotionEvent.ACTION_MOVE)   str="ACTION_MOVE";
        if (ballAction==MotionEvent.ACTION_UP)     str="ACTION_UP";
        if (ballAction==MotionEvent.ACTION_CANCEL) str="ACTION_CANCEL";
        canvas.drawText("TrackballAction>"+str,0,40*4,paint);        
    }

    //^b`Cxg̏
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        touchX=(int)event.getX();
        touchY=(int)event.getY();
        touchAction=event.getAction();
        return true;
    }     
    
    //gbN{[Cxg̏
    @Override    
    public boolean onTrackballEvent(MotionEvent event) {
        ballX=(int)(event.getX()*100);
        ballY=(int)(event.getY()*100);
        ballAction=event.getAction();
        return true;
    }
}