package net.npaka.checkboxex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;

//`FbN{bNXƃWI{^̗p
public class CheckBoxEx extends Activity 
    implements View.OnClickListener {
    private final static String BR=//s(3)
        System.getProperty("line.separator");
    
    private CheckBox   checkBox;  //`FbN{bNX
    private RadioGroup radioGroup;//WIO[v
    private Button     button;    //{^
    
    //
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);             

        //`FbN{bNX̐(1)
        checkBox=new CheckBox(this);
        checkBox.setText("`FbN{bNX");
        checkBox.setTextColor(Color.rgb(0,0,0));
        setLLParams(checkBox);  
        layout.addView(checkBox);

        //WI{^0̐(2)
        RadioButton radio0=new RadioButton(this);
        radio0.setId(0);
        radio0.setText("WI{^0");
        radio0.setTextColor(Color.rgb(0,0,0));
        
        //WI{^1̐(2)
        RadioButton radio1=new RadioButton(this);
        radio1.setId(1);
        radio1.setText("WI{^1");
        radio1.setTextColor(Color.rgb(0,0,0));
        
        //WIO[v̐(2)
        radioGroup=new RadioGroup(this);
        radioGroup.addView(radio0);
        radioGroup.addView(radio1);     
        radioGroup.check(0);
        setLLParams(radioGroup);        
        layout.addView(radioGroup);        

        //{^̐
        button=new Button(this);
        button.setText("ʕ\");
        button.setOnClickListener(this);
        setLLParams(button);
        layout.addView(button);
    }

    //{^NbNCxg̏
    public void onClick(View v) {
        //`FbN{bNXƃWI{^̏Ԏ擾(1)(2)
        showDialog(this,"",
            "`FbN{bNX>"+checkBox.isChecked()+BR+
            "WI{^>"+radioGroup.getCheckedRadioButtonId());
    }    
    
    //_CAO̕\
    private static void showDialog(final Activity activity,
        String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }    
    
    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  
}