package net.npaka.socketex;
import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

//\PbgʐM
public class SocketEx extends Activity    
    implements View.OnClickListener {
    private final static String BR=//s
        System.getProperty("line.separator");
    private final static String IP=//IPAhX̎w(1)
        "172.16.200.37";//ύXK{
    
    private TextView lblReceive;//Mx
    private EditText edtSend;   //MGfBbgeLXg
    private Button   btnSend;   //M{^
    
    private Socket       socket; //\Pbg
    private InputStream  in;     //̓Xg[
    private OutputStream out;    //o̓Xg[  
    
    private final Handler handler=new Handler();//nh(6)
    
    //
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        
        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout); 
        
        //MGfBbgeLXg̐
        edtSend=new EditText(this);
        edtSend.setId(2);
        edtSend.setText("",TextView.BufferType.NORMAL);
        setLLParams(edtSend,
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.WRAP_CONTENT);  
        layout.addView(edtSend);
        
        //M{^̐
        btnSend=new Button(this);
        btnSend.setText("M");
        btnSend.setOnClickListener(this);
        setLLParams(btnSend);  
        layout.addView(btnSend);

        //Mx̐
        lblReceive=new TextView(this);
        lblReceive.setId(1);
        lblReceive.setText("");
        lblReceive.setTextSize(16.0f);
        lblReceive.setTextColor(Color.rgb(0,0,0));
        setLLParams(lblReceive,
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.WRAP_CONTENT);  
        layout.addView(lblReceive);        
    }

    //Av̊Jn
    @Override
    public void onStart() {
        super.onStart();
        
        //Xbh̐(2)
        (new Thread(){public void run() {
            try {
                connect(IP,8080);
            } catch (Exception e) {
            }
        }}).start();
    }
    
    //Av̒~
    @Override
    public void onStop() {
        super.onStop();
        disconnect();
    }
    
    //MeLXg̒ǉ
    private void addText(final String text) {
        //nhɂ郆[U[C^tF[X(6)
        handler.post(new Runnable(){
            public void run() {
                lblReceive.setText(text+
                    BR+lblReceive.getText());
            }
        });
    }
    
    //ڑ
    private void connect(String ip,int port) {
        int size;
        String str;
        byte[] w=new byte[1024];        
        try {
            //\Pbgڑ(3)
            addText("ڑ");
            socket=new Socket(ip,port);
            in =socket.getInputStream();
            out=socket.getOutputStream();
            addText("ڑ");
            
            //M[v(4)
            while (socket!=null && socket.isConnected()) {
                //f[^̎M(5)
                size=in.read(w);
                if (size<=0) continue;
                str=new String(w,0,size,"UTF-8");

                //xւ̕ǉ
                addText(str);
            }
        } catch (Exception e) {
            addText("ʐMs܂");
        }
    }
    
    //ؒf
    private void disconnect() {
        try {
            socket.close();
            socket=null;
        } catch (Exception e) {
        }
    }

    //{^NbNCxg̏
    public void onClick(View v) {
        if (v==btnSend) {
            try {
                //f[^̑M(7)
                if (socket!=null && socket.isConnected()) {
                    byte[] w=edtSend.getText().toString().getBytes("UTF8");
                    out.write(w);
                    out.flush();
                    edtSend.setText("",TextView.BufferType.NORMAL);
                }
            } catch (Exception e) {
                addText("ʐMs܂");
            }           
        }
    }    

    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  

    //Ci[CAEg̃p[^w
    private static void setLLParams(View view,int w,int h) {
        view.setLayoutParams(new LinearLayout.LayoutParams(w,h));
    }
}