package net.npaka.dbproviderex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.ContentValues;
import android.content.DialogInterface;
import android.database.Cursor;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;

//DB񋟂RecvoC_
public class DBProviderEx extends Activity 
    implements View.OnClickListener {
    private EditText editText;//GfBbgeLXg
    private Button   btnWrite;//݃{^
    private Button   btnRead; //ǂݍ݃{^
    
    //
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);            
        
        //GfBbgeLXg̐
        editText=new EditText(this);
        setLLParams(editText,
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.WRAP_CONTENT);
        layout.addView(editText);

        //݃{^̐
        btnWrite=new Button(this);
        btnWrite.setText("");
        btnWrite.setOnClickListener(this);
        setLLParams(btnWrite);  
        layout.addView(btnWrite);        

        //ǂݍ݃{^̐
        btnRead=new Button(this);
        btnRead.setText("ǂݍ");
        btnRead.setOnClickListener(this);
        setLLParams(btnRead);  
        layout.addView(btnRead);
    }

    //{^NbNCxg̏
    public void onClick(View v) {
        if (v==btnWrite) {
            try {
                writeDB(editText.getText().toString());
            } catch (Exception e) {
                showDialog(this,"G[","ݎs܂ ");
            }            
        } else if (v==btnRead) {
            try {
                editText.setText(readDB());               
            } catch (Exception e) {
                showDialog(this,"G[","ǂݍݎs܂ "+e.toString());
            }            
        }
    }    
    
    //DBւ̏
    private void writeDB(String info) throws Exception {
        //RecvoC_񋟂f[^x[XURI(1)
        Uri uri=Uri.parse("content://net.npaka.dbprovider/"); 
       
        //RecvoC_񋟂f[^x[Xւ̃ANZX(2)
        ContentValues cv=new ContentValues();
        cv.put("id","0");
        cv.put("info",info);
        this.getContentResolver().update(uri,cv,null,null);
    }

    //DB̓ǂݍ
    private String readDB() throws Exception {
        //RecvoC_񋟂f[^x[XURI(1)
        Uri uri=Uri.parse("content://net.npaka.dbprovider/"); 
        
        //RecvoC_񋟂f[^x[Xւ̃ANZX(2)
        Cursor c=this.getContentResolver().query(uri,
            new String[]{"id","info"},"id='0'",null,null);
        if (c.getCount()==0) throw new Exception();
        c.moveToFirst();
        String str=c.getString(1);
        c.close();
        return str;
    }
    
    //_CAO̕\
    private static void showDialog(final Activity activity,String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }    
    
    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    } 

    //Ci[CAEg̃p[^w
    private static void setLLParams(View view,int w,int h) {
        view.setLayoutParams(new LinearLayout.LayoutParams(w,h));
    }
}