package net.npaka.cameraex;
import android.content.Context;
import android.hardware.Camera;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import java.io.FileOutputStream;

//J̐
public class CameraView extends SurfaceView 
    implements SurfaceHolder.Callback,Camera.PictureCallback {
    private SurfaceHolder holder;//z_[
    private Camera        camera;//J
    
    //RXgN^
    public CameraView(Context context) {
        super(context);
        
        //T[tFCXz_[̐
        holder=getHolder();
        holder.addCallback(this);
        
        //vbVobbt@̎w(1)
        holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }

    //T[tFCXCxg̏
    public void surfaceCreated(SurfaceHolder holder) {
        //J̏(2)
        try {
            camera=Camera.open();
            camera.setPreviewDisplay(holder);
        } catch (Exception e) {
        }
    }

    //T[tFCXύXCxg̏
    public void surfaceChanged(SurfaceHolder holder,int format,int w,int h) {
        //Jvr[̊Jn(1)
        camera.startPreview();
    }
    
    //T[tFCXCxg̏
    public void surfaceDestroyed(SurfaceHolder holder) {
        //J̃vr[~(2)
        camera.setPreviewCallback(null);
        camera.stopPreview();
        camera.release();
        camera=null;
    }
    //^b`Cxg̏
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        if (event.getAction()==MotionEvent.ACTION_DOWN) {
            //J̃XN[Vbg̎擾
            camera.takePicture(null,null,this); 
        }
        return true;
    }

    //ʐ^BeɌĂ΂
    public void onPictureTaken(byte[] data,Camera camera) {
        //t@CۑƃM[ւ̓o^
        try {
            data2sd(getContext(),data,"test.jpg");
        } catch (Exception e) {
            android.util.Log.e("",""+e.toString());
        }

        //vr[ĊJ
        camera.startPreview();
    }

    //oCgf[^SDJ[h
    private static void data2sd(Context context,
        byte[] w,String fileName) throws Exception {
        //SDJ[hւ̃f[^ۑi6j
        FileOutputStream fos=null;
        try {
            fos=new FileOutputStream("/sdcard/"+fileName);
            fos.write(w);
            fos.close();
        } catch (Exception e) {
            if (fos!=null) fos.close();
            throw e;
        }
    }
}