package net.npaka.mediarecorderex;
import java.io.File;

import android.app.Activity;
import android.content.Context;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.os.Environment;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.Window;

//^
public class VideoActivity extends Activity {
    //Av̏
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(new CameraView(this));
    }
    
    //Jr[
    class CameraView extends SurfaceView 
        implements SurfaceHolder.Callback {
        private SurfaceHolder holder;  //z_[
        private MediaRecorder recorder;//fBAR[_[
        
        //RXgN^
        public CameraView(Context context) {
            super(context);
            
            //T[tFCXz_[̐
            holder=getHolder();
            holder.addCallback(this);
            
            //vbVobbt@̎w
            holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
        }

        //T[tFCXCxg̏
        public void surfaceCreated(SurfaceHolder holder) {
            try {
                //^̊Jn(3)
                recorder=new MediaRecorder(); 
                recorder.setVideoSource(MediaRecorder.VideoSource.CAMERA);
                recorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4);
                recorder.setVideoEncoder(MediaRecorder.VideoEncoder.MPEG_4_SP);
                File dir=Environment.getExternalStorageDirectory();
                File file=File.createTempFile("test",".mp4",dir);
                recorder.setOutputFile(file.getAbsolutePath());
                recorder.setPreviewDisplay(holder.getSurface()); 
                recorder.prepare();
                recorder.start();
            } catch (Exception e) {
                android.util.Log.e("",e.toString());
            }
        }
        
        //T[tFCXύXCxg̏
        public void surfaceChanged(SurfaceHolder holder,
            int format,int w,int h) {
        }
        
        //T[tFCXCxg̏
        public void surfaceDestroyed(SurfaceHolder holder) {
            try {
                //^̒~(4)
                recorder.stop();
                recorder.release();
            } catch (Exception e) {
            }
        }
    }
}
