package net.npaka.recognizespeechex;
import java.util.ArrayList;
import android.app.Activity;
import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.speech.RecognizerIntent;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;

//F
public class RecognizeSpeechEx extends Activity 
    implements View.OnClickListener {
    private static final int REQUEST_CODE=0;
    private EditText editText;//GfBbgeLXg
    private Button   button;  //{^
    
    //Av̏
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);       
        
        //GfBbgeLXg̐
        editText=new EditText(this);
        editText.setText("",
            EditText.BufferType.NORMAL);
        setLLParams(editText,
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.WRAP_CONTENT);
        layout.addView(editText);
        
        //{^̐
        button=new Button(this);
        button.setText("F");
        button.setOnClickListener(this);
        setLLParams(button);  
        layout.addView(button);
    }

    //{^NbNCxg̏
    public void onClick(View v) {
        try {
            //F̎s(1)
            Intent intent=new Intent(
                RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
            intent.putExtra(
                RecognizerIntent.EXTRA_LANGUAGE_MODEL,
                RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
            intent.putExtra(
                RecognizerIntent.EXTRA_PROMPT,
                "RecognizeSpeechEx");
            startActivityForResult(intent,REQUEST_CODE);
        } catch (ActivityNotFoundException e) {
            Toast.makeText(RecognizeSpeechEx.this,
                "ActivityNotFoundException",Toast.LENGTH_LONG).show();
        }        
    }    
    
    //ANeBreBIɌĂ΂
    protected void onActivityResult(int requestCode,
        int resultCode,Intent data) {
        //Fʂ̎擾(2)
        if (requestCode==REQUEST_CODE && resultCode==RESULT_OK) {
            String str="";
            ArrayList<String> results=
                data.getStringArrayListExtra(
                RecognizerIntent.EXTRA_RESULTS);
            for (int i=0;i<results.size();i++) {
                str+=results.get(i)+" ";
            }
            editText.setText(str);
        }
        super.onActivityResult(requestCode,resultCode,data);
    }
    
    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  

    //Ci[CAEg̃p[^w
    private static void setLLParams(View view,int w,int h) {
        view.setLayoutParams(new LinearLayout.LayoutParams(w,h));
    }
}