package net.npaka.moguratataki;
import android.content.res.*;
import android.content.*;
import android.graphics.*;
import android.view.*;
import java.util.ArrayList;
import java.util.Random;

//炽r[
public class MoguraView extends SurfaceView 
    implements SurfaceHolder.Callback,Runnable {
    //V[萔(1)
    private final static int
        S_TITLE   =0,
        S_PLAY    =1,
        S_GAMEOVER=2;
    
    //VXe
    private SurfaceHolder holder;//T[tFCXz_[
    private Thread        thread;//Xbh
    private Graphics      g;     //OtBbNX
    
    //Q[
    private int  init=S_TITLE;//(1)
    private int  scene;       //V[(1)
    private int  score;       //XRA
    private long endTime;     //I
    private ArrayList<Mogura> moguras;//
    
    //RXgN^
    public MoguraView(Context context) {
        super(context);

        //摜̓ǂݍ
        Resources r=getResources();
        Mogura.bmp[0]=BitmapFactory.decodeResource(r,R.drawable.mogura0);
        Mogura.bmp[1]=BitmapFactory.decodeResource(r,R.drawable.mogura1);
        Mogura.bmp[2]=BitmapFactory.decodeResource(r,R.drawable.mogura2);
        
        //OtBbNX̐
        holder=getHolder();
        holder.addCallback(this);
        g=new Graphics(holder);
    }

    //T[tFCX̐
    public void surfaceCreated(SurfaceHolder holder) {
        thread=new Thread(this);
        thread.start();
    }

    //T[tFCX̏I
    public void surfaceDestroyed(SurfaceHolder holder) {
        thread=null;
    }

    //T[tFCX̕ύX
    public void surfaceChanged(SurfaceHolder holder,
        int format,int w,int h) {
    }   
      
    //Xbh̏
    public void run() {
        String str;
        
        //(2)
        while(thread!=null) {
            //V[̏
            if (init>=0) {
                scene=init;
                init=-1;
                
                //^Cg̏
                if (scene==S_TITLE) {
                    score=0;
                    moguras=new ArrayList<Mogura>();
                    int dy=80;
                    for (int i=0;i<10;i++) {
                        moguras.add(new Mogura(rand(getWidth()/2-80),dy));
                        moguras.add(new Mogura(
                            getWidth()/2+rand(getWidth()/2-80),dy));
                        dy+=30;
                    }
                } 
                //vC̏
                else if (scene==S_PLAY) {
                    endTime=System.currentTimeMillis()+30000;
                }
                //Q[I[o[̏
                else if (scene==S_GAMEOVER) {
                    endTime=System.currentTimeMillis()+3000;
                }
            }
            
            //wi̕`
            g.lock();
            g.setColor(Color.rgb(88,197,241));
            g.fillRect(0,0,getWidth(),100);
            g.setColor(Color.rgb(144,198,116));
            g.fillRect(0,100,getWidth(),getHeight()-100);
            
            //̕`
            for (int i=0;i<moguras.size();i++) {
                if (scene==S_PLAY) moguras.get(i).tick();
                moguras.get(i).draw(g);
            }
            
            //XRA̕`
            g.setColor(Color.rgb(255,0,0));
            g.setFontSize(20);
            str="Score";
            g.drawString(str,(120-g.stringWidth(str))/2,20);
            str=""+score;
            g.setFontSize(60);
            g.drawString(str,(120-g.stringWidth(str))/2,80);

            //Ԃ̕`
            g.setColor(Color.rgb(40,40,125));
            g.setFontSize(20);
            str="Time";
            g.drawString(str,getWidth()-120+(120-g.stringWidth(str))/2,20);
            g.setFontSize(40);
            int time=(int)(endTime-System.currentTimeMillis())/1000;
            if (scene!=S_PLAY) {
                str="00:00";
            } else if (time<=0) {
                str="00:00";
                init=S_GAMEOVER;
            } else if (time<10) {
                str="00:0"+time;
            } else {
                str="00:"+time;
            }
            g.drawString(str,getWidth()-120+(120-g.stringWidth(str))/2,70);

            //bZ[W̕`
            if (scene==S_TITLE || scene==S_GAMEOVER) {
                if (scene==S_TITLE)    str="炽";
                if (scene==S_GAMEOVER) str="Q[I[o[";
                g.setColor(Color.rgb(255,0,0));
                g.setFontSize(80);
                g.drawString(str,(getWidth()-g.stringWidth(str))/2,200);
            }
            g.unlock();
            
            //X[v
            try {
                Thread.sleep(50);
            } catch (Exception e) {
            }
        }
    }

    //^b`Cxg̏
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        int touchX=(int)event.getX();
        int touchY=(int)event.getY();
        int touchAction=event.getAction();
        if (touchAction==MotionEvent.ACTION_DOWN) {
            if (scene==S_TITLE) {
                init=S_PLAY;
            } else if (scene==S_PLAY) {
                for (int i=0;i<moguras.size();i++) {
                    if (moguras.get(i).isHit(touchX,touchY)) score++;
                }
            } else if (scene==S_GAMEOVER) {
                if (endTime<System.currentTimeMillis()) init=S_TITLE;
            }
        }
        return true;
    } 
    
    //̎擾(3)
    private static Random rand=new Random();
    public static int rand(int num) {
        return (rand.nextInt()>>>1)%num;
    }    
}