package net.npaka.keyex;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.Window;

//L[Cxg̏
public class KeyEx extends Activity {
    private KeyView     keyView;    //L[r[
    private TickHandler tickHandler;//nh
    
    //Av̏(1)
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        keyView=new KeyView(this);
        setContentView(keyView);
    }

    //Av̍ĊJ(1)
    @Override
    public void onResume() {
        super.onResume();
        tickHandler=new TickHandler();
        tickHandler.sleep(0);
    }    
    
    //Av̈ꎞ~(1)
    @Override
    public void onPause() {
        super.onPause();
        tickHandler=null;
    }    
    
    //nh(2)
    public class TickHandler extends Handler {
        //nhbZ[W
        @Override 
        public void handleMessage(Message msg) {
            keyView.invalidate();
            if (tickHandler!=null) tickHandler.sleep(100);
        }
        
        //X[v
        public void sleep(long delayMills) {
            removeMessages(0);
            sendMessageDelayed(obtainMessage(0),delayMills);
        }
    }
}