package net.npaka.keyex;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.KeyEvent;
import android.view.View;

//L[Cxg̏
public class KeyView extends View {
    private int keyCode=-999;//
    
    //RXgN^
    public KeyView(Context context) {
        super(context);
        setBackgroundColor(Color.WHITE);

        //tH[JXw(5)
        setFocusable(true);
        setFocusableInTouchMode(true);
    }
    
    //`
    @Override 
    protected void onDraw(Canvas canvas) {
        //yCg
        Paint paint=new Paint();       
        paint.setAntiAlias(true);
        paint.setTextSize(32);
        
        //L[R[h̕`
        String str="";
        if (keyCode==KeyEvent.KEYCODE_DPAD_UP)    str="DPAD_UP";
        if (keyCode==KeyEvent.KEYCODE_DPAD_DOWN)  str="DPAD_DOWN";
        if (keyCode==KeyEvent.KEYCODE_DPAD_LEFT)  str="DPAD_LEFT";
        if (keyCode==KeyEvent.KEYCODE_DPAD_RIGHT) str="DPAD_RIGHT";
        canvas.drawText("KeyCode>"+keyCode+" "+str,0,40,paint);
    }
    
    //L[_ECxg̏(6)
    @Override 
    public boolean onKeyDown(int keyCode,KeyEvent event) {
        this.keyCode=keyCode;
        return super.onKeyDown(keyCode,event);
    }

    //L[AbvCxg̏(6)
    @Override 
    public boolean onKeyUp(int keyCode,KeyEvent event) {
        this.keyCode=-1;
        return super.onKeyUp(keyCode,event);
    }
}