package net.npaka.buttonex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.LinearLayout;

//{^ƃ_CAO
public class ButtonEx extends Activity 
    implements View.OnClickListener {
    private Button      button;     //{^
    private ImageButton imageButton;//C[W{^
        
    //
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);
        
        //{^̐(1)
        button=new Button(this);
        button.setText("{^");
        button.setOnClickListener(this);//(2)
        setLLParams(button);
        layout.addView(button);

        //摜̓ǂݍ
        Bitmap image=BitmapFactory.decodeResource(
            getResources(),R.drawable.sample);        
        
        //C[W{^̐(3)
        imageButton=new ImageButton(this);
        imageButton.setImageBitmap(image);
        imageButton.setOnClickListener(this); 
        setLLParams(imageButton);
        layout.addView(imageButton);
    }
    
    //{^NbNCxg̏(2)
    public void onClick(View view) {
        //{^̏
        if (view==button) {
            showDialog(this,"","{^ ");
        } 
        //C[W{^̏
        else if (view==imageButton) {
            showDialog(this,"","C[W{^ ");
        }
    }   
    
    //_CAO̕\(4)
    private static void showDialog(final Activity activity,
        String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }

    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  
}