package net.npaka.webviewex;
import android.app.*;
import android.os.*;
import android.view.*;
import android.webkit.*;

//JavaScriptƂ̘Ag
public class WebViewEx extends Activity {
    private WebView webView;//Webr[
    private Handler handler;//nh[

    //
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //nh[̐
        handler=new Handler();    
        
        //Webr[̐(1)
        webView=new WebView(this);       
        WebSettings settings=webView.getSettings();
        settings.setJavaScriptEnabled(true);
        settings.setSavePassword(false);
        settings.setSaveFormData(false);
        settings.setSupportZoom(false);
        
        //JavaScriptC^tF[X̐(2)
        webView.addJavascriptInterface(new JSInterface(),"demo");
        
        //WebChromeClientNX̌pNX̐i3j
        webView.setWebChromeClient(new ChromeClient());
        
        //HTML̓ǂݍ݁i4j
        webView.loadUrl("file:///android_asset/sample.html");
        setContentView(webView); 
    }

    //JSC^tF[X(2)
    public final class JSInterface {
        //RXgN^
        public JSInterface() {
        }

        //JavaScriptC^tF[X̃\bh̏i5j
        public void onClick() {
            handler.post(new Runnable() {
                public void run() {
                    webView.loadUrl("javascript:changeImage()");
                }
            });
        }
    }

    //WebChromeClientNX̌pNX̐i3j
    public final class ChromeClient extends WebChromeClient {
        //A[gCxg̏
        @Override
        public boolean onJsAlert(WebView view,
            String url,String message,JsResult result) {
            android.util.Log.e("",message);
            result.confirm();
            return true;
        }
    }
}