package net.npaka.fileex;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

//t@C̓ǂݏ
public class FileEx extends Activity 
    implements View.OnClickListener {
    private EditText editText;//GfBbgeLXg
    private Button   btnWrite;//݃{^
    private Button   btnRead; //ǂݍ݃{^
    
    //
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);            
        
        //GfBbgeLXg̐
        editText=new EditText(this);
        editText.setText("",EditText.BufferType.NORMAL);
        setLLParams(editText,
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.WRAP_CONTENT);
        layout.addView(editText);

        //݃{^̐
        btnWrite=new Button(this);
        btnWrite.setText("");
        btnWrite.setOnClickListener(this);
        setLLParams(btnWrite);  
        layout.addView(btnWrite);        

        //ǂݍ݃{^̐
        btnRead=new Button(this);
        btnRead.setText("ǂݍ");
        btnRead.setOnClickListener(this);
        setLLParams(btnRead);  
        layout.addView(btnRead); 
    }

    //{^NbNCxg̏
    public void onClick(View v) {
        if (v==btnWrite) {
            try {
                String str=editText.getText().toString();
                str2file(this,str,"test.txt");
            } catch (Exception e) {
                showDialog(this,"G[","ݎs܂ ");
            }            
        } else  if (v==btnRead) {
            try {
                String str=file2str(this,"test.txt");
                editText.setText(str,TextView.BufferType.EDITABLE);        
            } catch (Exception e) {
                showDialog(this,"G[","ǂݍݎs܂ ");
            }            
        }
    }     
    
  //̃oCgzϊ(1)
    private static void str2file(Context context,
        String str,String fileName) throws Exception {
        data2file(context,str.getBytes(),fileName);
    }      

    //oCgz̕ϊ(2)
    private static String file2str(Context context,
        String fileName) throws Exception {  
        byte[] w=file2data(context,fileName);
        return new String(w);
    }    
    
    //oCgf[^t@C
    private static void data2file(Context context,
        byte[] w,String fileName) throws Exception {
        OutputStream out=null;
        try {
            //t@Co̓Xg[̃I[v(3)
            out=context.openFileOutput(fileName,
                Context.MODE_PRIVATE);
            
            //oCgz̏(4)
            out.write(w,0,w.length);
            
            //t@Co̓Xg[̃N[Y(5)
            out.close();
        } catch (Exception e) {
            try {
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            throw e;
        }
    } 
    
    //t@CoCgf[^
    private static byte[] file2data(Context context,
        String fileName) throws Exception {
        int size;
        byte[] w=new byte[1024]; 
        InputStream in=null;
        ByteArrayOutputStream out=null;
        try {
            //t@C̓Xg[̃I[v(6)
            in=context.openFileInput(fileName);
            
            //oCgz̓ǂݍ(7)
            out=new ByteArrayOutputStream();
            while (true) {
                size=in.read(w);
                if (size<=0) break;
                out.write(w,0,size);
            }
            out.close();
            
            //t@C̓Xg[̃N[Y(8)
            in.close();
            
            //ByteArrayOutputStreamIuWFNg̃oCgz(9)
            return out.toByteArray();
        } catch (Exception e) {
            try {
                if (in!=null) in.close();
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
            throw e;
        }
    }
    
    //_CAO̕\
    private static void showDialog(final Activity activity,
        String title,String text) {
        AlertDialog.Builder ad=new AlertDialog.Builder(activity);
        ad.setTitle(title);
        ad.setMessage(text);
        ad.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                activity.setResult(Activity.RESULT_OK);
            }
        });
        ad.create();
        ad.show();
    }    
    
    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }  

    //Ci[CAEg̃p[^w
    private static void setLLParams(View view,int w,int h) {
        view.setLayoutParams(new LinearLayout.LayoutParams(w,h));
    }
}