package net.npaka.serviceex;
import android.app.PendingIntent;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.IBinder;
import android.widget.Toast;

//v[[T[rX
public class PlayerService extends Service //(3)
    implements MediaPlayer.OnCompletionListener {
    private MediaPlayer player;//v[[

    //
    @Override
    public void onStart(Intent intent,int startID) {
        //meBtBP[V̕\
        showNotification(this,R.drawable.icon,
            "BGMĐ܂",
            "vC[T[rX",
            "vC[T[rXJn܂");

        //TEh̍Đ
        playSound();
    }

    //㏈
    @Override
    public void onDestroy() {
        //meBtBP[V}l[W̎擾
        NotificationManager nm;
        nm=(NotificationManager)getSystemService(
            Context.NOTIFICATION_SERVICE);
        
        //meBtBP[ṼLZ(6)
        nm.cancel(0);
        
        //TEh̒~
        stopSound();
        
        //g[Xg̕\
        showToast(this,"v[[T[rX~܂");
    }
    
    //oCh
    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }

    //TEh̍Đ
    public void playSound() {
        try {
            player=MediaPlayer.create(this,R.raw.sample);
            player.start();
            player.setOnCompletionListener(this);
        } catch (Exception e) {
        }
    }

    //TEh̒~
    public void stopSound() {
        try {
            player.stop();
            player.setOnCompletionListener(null);
            player.release();
            player=null;
        } catch (Exception e) {
        }
    }

    //TEhĐIɌĂ΂
    public void onCompletion(MediaPlayer mediaPlayer) {
        stopSound();
    }
    
    //meBtBP[V̕\
    private void showNotification(Context context,
        int iconID,String ticker,String title,String message) {
        //meBtBP[V}l[W̎擾(4)
        NotificationManager nm;
        nm=(NotificationManager)getSystemService(
            Context.NOTIFICATION_SERVICE);
    
        //meBtBP[VIuWFNg̐(5)
        Notification notification=new Notification(iconID,
            ticker,System.currentTimeMillis());
        PendingIntent intent=PendingIntent.getActivity(context,0,
            new Intent(context,net.npaka.serviceex.ServiceEx.class),0);
        notification.setLatestEventInfo(context,
            title,message,intent);
        
        //meBtBP[ṼLZ(6)
        nm.cancel(0);
        
        //meBtBP[V̕\(7)
        nm.notify(0,notification);
    }

    //g[Xg̕\
    private static void showToast(Context context,String text) {
        Toast.makeText(context,text,Toast.LENGTH_SHORT).show();
    }
}