package net.npaka.mediarecorderex;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.LinearLayout;

//
public class MediaRecorderEx extends Activity 
    implements View.OnClickListener {
    private Button btnAudio;//^Jn{^
    private Button btnVideo;//^Jn{^
    
    //Av̏
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setBackgroundColor(Color.rgb(255,255,255));
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);       
        
        //^Jn̐
        btnAudio=new Button(this);
        btnAudio.setText("^Jn");
        btnAudio.setOnClickListener(this);
        setLLParams(btnAudio);  
        layout.addView(btnAudio);        

        //^Jn̐
        btnVideo=new Button(this);
        btnVideo.setText("^Jn");
        btnVideo.setOnClickListener(this);
        setLLParams(btnVideo);  
        layout.addView(btnVideo);        
    }
    
    //{^NbNCxg̏
    public void onClick(View v) {
        if (v==btnAudio) {
            Intent intent=new Intent(this,
                net.npaka.mediarecorderex.AudioActivity.class);
            startActivity(intent);
        } else if (v==btnVideo) {
            Intent intent=new Intent(this,
                net.npaka.mediarecorderex.VideoActivity.class);
            startActivity(intent);
        } 
    }    
    
    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }
}