package net.npaka.rpg;
import android.content.res.*;
import android.content.*;
import android.graphics.*;
import android.view.*;
import java.util.Random;

//RPGr[
public class RPGView extends SurfaceView 
    implements SurfaceHolder.Callback,Runnable {
    //VXe萔
    private final static int//V[(1)
        S_MAP    =0,//}bv
        S_APPEAR =1,//o
        S_COMMAND=2,//R}h
        S_ATTACK =3,//U
        S_DEFENCE=4,//h
        S_ESCAPE =5;//
    private final static int//L[
        KEY_NONE  =-1,
        KEY_LEFT  =0,
        KEY_RIGHT =1,
        KEY_UP    =2,
        KEY_DOWN  =3,
        KEY_1     =4,
        KEY_2     =5,
        KEY_SELECT=6;
    private final static int[][] MAP={//}bv(2)
        {3,3,3,3,3,3,3,3,3,3},
        {3,1,0,0,0,0,3,0,0,3},
        {3,0,0,0,0,0,3,3,0,3},
        {3,0,3,3,3,3,3,3,0,3},
        {3,0,0,3,0,0,0,3,0,3},
        {3,3,0,3,0,3,3,3,0,3},
        {3,0,0,3,0,0,0,0,0,3},
        {3,0,3,3,0,3,0,3,3,3},
        {3,0,0,0,0,3,0,0,2,3},
        {3,3,3,3,3,3,3,3,3,3}};

    //EҒ萔(3)
    private final static int[] 
        YU_MAXHP  ={0,30,50,70},//ő̗
        YU_ATTACK ={0,5,10,30}, //U
        YU_DEFENCE={0,0,5,10},  //
        YU_EXP    ={0,0,3,6};   //Kvol

    //G萔(4)
    private final static String[] 
        EN_NAME={"XX","Oh"};//O
    private final static int[] 
        EN_MAXHP  ={10,50},//ő̗
        EN_ATTACK ={10,26},//U
        EN_DEFENCE={0,16}, //
        EN_EXP    ={1,99}; //擾ol

    //VXe
    private int      init=S_MAP;//(1)
    private int      scene;     //V[(1)
    private int      key;       //L[
    private int      w;         //
    private int      h;         //
    private Graphics g;         //OtBbN
    private Bitmap[] bmp=new Bitmap[7];//rbg}bv
    private SurfaceHolder holder;//T[tFCXz_[
    private Thread        thread;//Xbh

    //E҃p[^(3)
    private int yuX  =1; //XW
    private int yuY  =2; //YW
    private int yuLV =1; //x
    private int yuHP =30;//̗
    private int yuEXP=0; //ol

    //Gp[^(4)
    private int enType;//
    private int enHP;  //̗
    
    //RXgN^
    public RPGView(Context context) {
        super(context);

        //摜̓ǂݍ
        Resources r=getResources();
        bmp[0]=BitmapFactory.decodeResource(r,R.drawable.rpg0);
        bmp[1]=BitmapFactory.decodeResource(r,R.drawable.rpg1);
        bmp[2]=BitmapFactory.decodeResource(r,R.drawable.rpg2);
        bmp[3]=BitmapFactory.decodeResource(r,R.drawable.rpg3);
        bmp[4]=BitmapFactory.decodeResource(r,R.drawable.rpg4);
        bmp[5]=BitmapFactory.decodeResource(r,R.drawable.rpg5);
        bmp[6]=BitmapFactory.decodeResource(r,R.drawable.rpg6);
        
        //OtBbNX̐
        holder=getHolder();
        holder.addCallback(this);
        g=new Graphics(holder);
    }

    //T[tFCX̐
    public void surfaceCreated(SurfaceHolder holder) {
        thread=new Thread(this);
        thread.start();
    }

    //T[tFCX̏I
    public void surfaceDestroyed(SurfaceHolder holder) {
        thread=null;
    }

    //T[tFCX̕ύX
    public void surfaceChanged(SurfaceHolder holder,
        int format,int w,int h) {
    }   
      
    //Xbh̏
    public void run() {
        String str;
        w=getWidth();
        h=getHeight();
        while(thread!=null) {
            //V[̏
            if (init>=0) {
                scene=init;
                init=-1;
                key =KEY_NONE;
            }
            
            //}bv
            if (scene==S_MAP) {
                //ړ
                boolean flag=false;
                if (key==KEY_UP) {
                    if (MAP[yuY-1][yuX]<=2) {yuY--;flag=true;}
                } else if (key==KEY_DOWN) {
                    if (MAP[yuY+1][yuX]<=2) {yuY++;flag=true;}
                } else if (key==KEY_LEFT) {
                    if (MAP[yuY][yuX-1]<=2) {yuX--;flag=true;}
                } else if (key==KEY_RIGHT) {
                    if (MAP[yuY][yuX+1]<=2) {yuX++;flag=true;}
                }

                //GǒvZ(5)
                if (flag) {
                    if (MAP[yuY][yuX]==0 && (rand.nextInt()>>>1)%10==0) {
                        enType=0;init=S_APPEAR;}
                    if (MAP[yuY][yuX]==1) yuHP=YU_MAXHP[yuLV];
                    if (MAP[yuY][yuX]==2) {enType=1;init=S_APPEAR;}
                }

                //`
                g.lock();
                for (int j=-3;j<=3;j++) {
                    for (int i=-5;i<=5;i++) {
                        int idx=3;
                        if (0<=yuX+i && yuX+i<MAP[0].length &&
                            0<=yuY+j && yuY+j<MAP.length) {
                            idx=MAP[yuY+j][yuX+i];
                        }
                        g.drawBitmap(bmp[idx],w/2-40+80*i,h/2-40+80*j);
                    }
                }
                g.drawBitmap(bmp[4],w/2-40,h/2-40);
                drawStatus();
                g.unlock();
            }
            //ȍ
            else if (scene==S_APPEAR) {
                //
                enHP=EN_MAXHP[enType];

                //tbV
                sleep(300);
                for (int i=0;i<6;i++) {
                    g.lock();
                    if (i%2==0) {
                        g.setColor(Color.rgb(0,0,0));
                    } else {
                        g.setColor(Color.rgb(255,255,255));
                    }
                    g.fillRect(0,0,w,h);
                    g.unlock();
                    sleep(100);
                }

                //bZ[W
                drawBattle(EN_NAME[enType]+"ꂽ");
                waitSelect();
                init=S_COMMAND;
            }
            //R}h
            else if (scene==S_COMMAND) {
                drawBattle("@@1.U@@2.");
                key=KEY_NONE;
                while (init==-1) {
                    if (key==KEY_1) init=S_ATTACK;
                    if (key==KEY_2) init=S_ESCAPE;
                    sleep(100);
                }
            }
            //Ȕ
            else if (scene==S_ATTACK) {
                //bZ[W
                drawBattle("E҂̍U");
                waitSelect();

                //tbV
                for (int i=0;i<10;i++) {
                    drawBattle("E҂̍U",i%2==0);
                    sleep(100);
                }

                //ǓvZ(6)
                int damage=YU_ATTACK[yuLV]-EN_DEFENCE[enType]+
                    (rand.nextInt()>>>1)%10;
                if (damage<= 1) damage= 1;
                if (damage>=99) damage=99;
                
                //bZ[W
                drawBattle(damage+"_[W^I");
                waitSelect();
                
                //̗͂̌vZ
                enHP-=damage;
                if (enHP<=0) enHP=0;

                //
                init=S_DEFENCE;
                if (enHP==0) {
                    //bZ[W
                    drawBattle(EN_NAME[enType]+"|");
                    waitSelect();

                    //olvZ
                    yuEXP+=EN_EXP[enType];
                    if (yuLV<3 && YU_EXP[yuLV+1]<=yuEXP) {
                        yuLV++;
                        drawBattle("xAbv");
                        waitSelect();
                    }

                    //GfBO
                    if (enType==1) {
                        g.lock();
                        g.setColor(Color.rgb(0,0,0));
                        g.fillRect(0,0,w,h);
                        g.setColor(Color.rgb(255,255,255));
                        g.setFontSize(32);
                        str="Fin.";
                        g.drawString(str,(w-g.stringWidth(str))/2,200);
                        g.unlock();
                        waitSelect();
                        RPG.exit();
                    }
                    init=S_MAP;
                }
            }
            //GU
            else if (scene==S_DEFENCE) {
                //bZ[W
                drawBattle(EN_NAME[enType]+"̍U");
                waitSelect();

                //tbV
                for (int i=0;i<10;i++) {
                    if (i%2==0) {
                        g.lock();
                        g.setColor(Color.rgb(255,255,255));
                        g.fillRect(0,0,w,h);
                        g.unlock();
                    } else {
                        drawBattle(EN_NAME[enType]+"̍U");
                    }
                    sleep(100);
                }

                //ȟvZ(7)
                int damage=EN_ATTACK[enType]-YU_DEFENCE[yuLV]+
                    (rand.nextInt()>>>1)%10;
                if (damage<= 1) damage= 1;
                if (damage>=99) damage=99;
                
                //bZ[W
                drawBattle(damage+"_[W󂯂I");
                waitSelect();
                
                //̗͂̌vZ
                yuHP-=damage;
                if (yuHP<=0) yuHP=0;

                //sk
                init=S_COMMAND;
                if (yuHP==0) {
                    drawBattle("E҂͗͐s");
                    waitSelect();
                    RPG.exit();
                }
            }
            //
            else if (scene==S_ESCAPE) {
                //bZ[W
                drawBattle("E҂͓o");
                waitSelect();

                //̌vZ(8)
                init=S_MAP;
                if (enType==1 || (rand.nextInt()>>>1)%100<=10) {
                    drawBattle(EN_NAME[enType]+"͉荞");
                    waitSelect();
                    init=S_DEFENCE;
                }
            }            
            //X[v
            key=KEY_NONE;
            sleep(200);
        }
    }

    //퓬ʂ̕`
    private void drawBattle(String message) {
        drawBattle(message,enHP>=0);
    }
    
    //퓬ʂ̕`
    private void drawBattle(String message,boolean visible) {
        int color=(yuHP!=0)?Color.rgb(0,0,0):Color.rgb(2555,0,0);
        g.lock();
        g.setColor(color);
        g.fillRect(0,0,w,h);
        drawStatus();
        if (visible) {
            g.drawBitmap(bmp[5+enType],
                (w-bmp[5+enType].getWidth())/2,
                h-100-bmp[5+enType].getHeight());
        }
        g.setColor(Color.rgb(255,255,255));
        g.fillRect((w-504)/2,h-122,504,104);
        g.setColor(color);
        g.fillRect((w-500)/2,h-120,500,100);
        g.setColor(Color.rgb(255,255,255));
        g.setFontSize(32);
        g.drawString(message,(w-500)/2+50,h-90);
        g.unlock();
    }
    
    //Xe[^X̕`
    private void drawStatus() {
        int color=(yuHP!=0)?Color.rgb(0,0,0):Color.rgb(255,0,0);
        g.setColor(Color.rgb(255,255,255));
        g.fillRect((w-504)/2,8,504,54);
        g.setColor(color);
        g.fillRect((w-500)/2,10,500,50);
        g.setColor(Color.rgb(255,255,255));
        g.setFontSize(32);
        g.drawString("Eҁ@LV"+yuLV+"@HP"+yuHP+
            "/"+YU_MAXHP[yuLV],(w-500)/2+50,48);
    }
    
    //^b`Cxg̏
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        int touchX=(int)event.getX();
        int touchY=(int)event.getY();
        int touchAction=event.getAction();
        if (touchAction==MotionEvent.ACTION_DOWN) {
            if (scene==S_MAP) {
                if (Math.abs(touchX-w/2)>Math.abs(touchY-h/2)) {
                    key=(touchX-w/2<0)?KEY_LEFT:KEY_RIGHT;
                } else {
                    key=(touchY-h/2<0)?KEY_UP:KEY_DOWN;
                }
            } else if (scene==S_APPEAR || scene==S_ATTACK || 
                scene==S_DEFENCE || scene==S_ESCAPE) {
                key=KEY_SELECT;
            } else if (scene==S_COMMAND) {
                if (264<touchX && touchX<264+120 &&
                    300<touchY && touchY<300+80) {
                    key=KEY_1;
                } else if (414<touchX && touchX<414+130 &&
                    300<touchY && touchY<300+80) {
                    key=KEY_2;
                }
            }
        }
        return true;
    } 
    
    //L[҂
    private void waitSelect() {
        key=KEY_NONE;
        while (key!=KEY_SELECT) sleep(100);
    }
    
    //X[v
    private void sleep(int time) {
        try {
            Thread.sleep(time);
        } catch (Exception e) {
        }
    }
    
    //̎擾
    private static Random rand=new Random();
    public static int rand(int num) {
        return (rand.nextInt()>>>1)%num;
    }    
}