package net.npaka.twitterclient;
import android.app.Activity;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

//ݒ
public class TwitterSetup extends Activity 
    implements View.OnClickListener {
    private EditText edtName;
    private EditText edtPassword;
    private Button   btnOK;
    
    //
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setResult(Activity.RESULT_CANCELED);

        //vt@X̓ǂݍ
        SharedPreferences pref=getSharedPreferences(
            "setup",MODE_PRIVATE);
        String name    =pref.getString("name","");
        String password=pref.getString("password","");

        //CAEg̐
        LinearLayout layout=new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);               

        //AJEg̐
        TextView textView=new TextView(this);
        textView.setText("AJEg");
        layout.addView(textView); 
        edtName=new EditText(this);
        edtName.setText(name);
        setLLParams(edtName,
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.WRAP_CONTENT);
        layout.addView(edtName); 
        
        //pX[h̐
        textView=new TextView(this);
        textView.setText("pX[h");
        layout.addView(textView); 
        edtPassword=new EditText(this);
        edtPassword.setText(password);
        setLLParams(edtPassword,
            LinearLayout.LayoutParams.FILL_PARENT,
            LinearLayout.LayoutParams.WRAP_CONTENT);
        layout.addView(edtPassword);
        
        //OK{^̐
        btnOK=new Button(this);
        btnOK.setText("OK");
        btnOK.setOnClickListener(this);
        setLLParams(btnOK);
        layout.addView(btnOK);
    }

    //{^NbNCxg̏
    public void onClick(View v) {
        if (v==btnOK) {
            //ۑ
            SharedPreferences pref=getSharedPreferences(
                "setup",MODE_PRIVATE);
            SharedPreferences.Editor editor=pref.edit();
            editor.putString("name",edtName.getText().toString());
            editor.putString("password",edtPassword.getText().toString());
            editor.commit();
            
            //ANeBreB̏I
            setResult(Activity.RESULT_OK);
            finish();
        }
    } 
    
    //Ci[CAEg̃p[^w
    private static void setLLParams(View view) {
        view.setLayoutParams(new LinearLayout.LayoutParams(
            LinearLayout.LayoutParams.WRAP_CONTENT,
            LinearLayout.LayoutParams.WRAP_CONTENT));
    }
    
    //Ci[CAEg̃p[^w
    private static void setLLParams(View view,int w,int h) {
        view.setLayoutParams(new LinearLayout.LayoutParams(w,h));
    }
}